read -p "WARNING!  This will overwrite existing expected test files.  Proceed?  (YES/NO): " answer
if [ "$answer" != "YES" ] ; then
  echo "Exiting.  No changes."
  exit;
fi

## 1) 
zcat $BIOR_CATALOG/dbSNP/137/00-All_GRCh37.tsv.bgz | head -100 | bior_drill -p INFO.GENEINFO > 1.out

## 2)
zcat $BIOR_CATALOG/dbSNP/137/00-All_GRCh37.tsv.bgz | head -100 | bior_overlap -d $BIOR_CATALOG/NCBIGene/GRCh37_p10/genes.tsv.bgz > 2.out

## 3)
cat /data5/bsi/BIOR/Test/sampleVariants50.vcf | bior_vcf_to_tjson | bior_same_variant -d /data5/bsi/catalogs/bior/v1/dbSNP/137/00-All_GRCh37.tsv.bgz | bior_drill -p _id | bior_lookup -d /data5/bsi/catalogs/bior/v1/dbSNP/137/00-All_GRCh37.tsv.bgz -p ID > 3.out

## 4)
cat /data5/bsi/BIOR/Test/sampleVariants50.vcf | bior_vcf_to_tjson | bior_annotate > 4.out

## 5)
# NOT IMPLEMENTED YET - THIS DEALS WITH DRILLING A JSON OBJECT (NOT AN INDIVIDUAL KEY-VALUE PAIR)


## 6)
cat /data5/bsi/BIOR/Test/sampleVariants50.vcf | bior_vcf_to_tjson | bior_drill -p INFO -k > 6.out

## 7)
cat /data5/bsi/BIOR/Test/sampleVariants50.vcf | bior_vcf_to_tjson | bior_pretty_print > 7.out

## 8)
cat /data5/bsi/BIOR/Test/sampleVariants50.vcf | bior_vcf_to_tjson | bior_overlap -d /data5/bsi/catalogs/bior/v1/dbSNP/137/00-All_GRCh37.tsv.bgz | bior_tjson_to_vcf > 8.out

## 9)
echo -e "#CHROM\tPOS\tID\tREF\tALT\tQUAL\tFILTER\tINFO\n22\t29138293\t.\tT\tC\t.\t.\t." | bior_vep --all > 9.out

##10)
echo -e "#CHROM\tPOS\tID\tREF\tALT\tQUAL\tFILTER\tINFO\n22\t29138293\t.\tT\tC\t.\t.\t." | bior_vep > 10.out

##11)
dir=/data5/bsi/BIOR/Vcfs
bior_concat -o 11.gz -i $dir/sample_rawvariants.20a.vcf  $dir/sample_rawvariants.20b.vcf

##12)
bior_merge -o 12.gz -i $dir/sample_rawvariants.20a.vcf  $dir/sample_rawvariants.20b.vcf

##13)
diff <(zcat 11.gz | grep -v "^##") <(zcat 12.gz | grep -v "^##")


##20)
cat TempV4/my.txt | bior_tjson_to_vcf -c 2 -r 1 > Expected/20.expected

##100)
bior_annotate_blaster  /data5/bsi/BIOR/Vcfs/sample_rawvariants.10k.vcf   100.vcf.gz  3000  Meiners.Michael1@mayo.edu

##101) 
bior_annotate < /data5/bsi/BIOR/Vcfs/sample_rawvariants.10k.vcf | gzip -c > 101.vcf.annot.gz

##102)
#(just a diff of previous two commands)
